<ngx-loading [show]="datasetIsLoadingUpdate$ | async" />

<section
  class="form-dataset-update"
  id="form-dataset-update"
>
  <form
    class="form"
    [formGroup]="myForm"
    (ngSubmit)="onSubmit($event)"
    (keydown.enter)="$event.stopPropagation()"
  >
    <jds-bi-accordion
      id="accordion-dataset-update"
      #acc="jdsBiAccordion"
      [destroyOnHide]="false"
      [closeOthers]="true"
      [activeIds]="'accordion-dataset-update-information'"
      [colorScheme]="colorScheme"
      [ngClass]="['accordion-dataset-update']"
    >
      <jds-bi-panel id="accordion-dataset-update-information">
        <ng-template jdsBiPanelTitle>
          <div
            [ngClass]="[jds.fs(18), jds.p(20)]"
            [style.width.%]="100"
            (click)="panelCollapse('accordion-dataset-update-information')"
          >
            Informasi Dataset
          </div>
        </ng-template>
        <ng-template jdsBiPanelContent>
          <div [ngClass]="[jds.p(20)]">
            <!-- Judul -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Judul <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Contoh : Indeks Keamanan Informasi"
                formControlName="name"
              />
              <ng-container
                *ngIf="f.name?.invalid && (f.name?.dirty || f.name?.touched)"
              >
                <div
                  *ngIf="f.name?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="f.name?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Deskripsi -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Deskripsi
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ckeditor
                class="ck-satudata"
                [ngClass]="jds.fs(14)"
                [editor]="Editor"
                [config]="EditorConfig"
                formControlName="description"
              ></ckeditor>
              <ng-container
                *ngIf="
                  f.description?.invalid &&
                  (f.description?.dirty || f.description?.touched)
                "
              >
                <div
                  *ngIf="f.description?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Topik -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Topik <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                #topikSelect
                [items]="topicData$ | async"
                bindValue="id"
                bindLabel="name"
                placeholder="Topik"
                formControlName="sektoral_id"
              />
              <ng-container
                *ngIf="
                  f.sektoral_id?.invalid &&
                  (f.sektoral_id?.dirty || f.sektoral_id?.touched)
                "
              >
                <div
                  *ngIf="f.sektoral_id?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Kategori Data -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Kategori Data
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                #categoryDatasetSelect
                [items]="categoryDatasetData"
                placeholder="Kategori Data"
                formControlName="category"
              />
              <ng-container
                *ngIf="
                  f.category?.invalid &&
                  (f.category?.dirty || f.category?.touched)
                "
              >
                <div
                  *ngIf="f.category?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Klasifikasi -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Klasifikasi
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                #klasifikasiSelect
                [items]="classificationDatasetData$ | async"
                (ngModelChange)="onSelectedClassificationDataset($event)"
                (clear)="onClearClassificationDataset()"
                bindValue="id"
                bindLabel="name"
                placeholder="Klasifikasi"
                formControlName="dataset_class_id"
              />
              <ng-container
                *ngIf="
                  f.dataset_class_id?.invalid &&
                  (f.dataset_class_id?.dirty || f.dataset_class_id?.touched)
                "
              >
                <div
                  *ngIf="f.dataset_class_id?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Hak Akses Data Dikecualikan -->
            <div
              *ngIf="isShowAccess"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Hak Akses Data Dikecualikan
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                class="select-tags"
                [items]="organizationInputData$ | async"
                [multiple]="true"
                [selectOnTab]="true"
                [typeahead]="organizationInput$"
                [loading]="organizationInputIsLoading"
                [hideSelected]="true"
                [minTermLength]="2"
                (add)="onAddAccessControl($event)"
                (remove)="onRemoveAccessControl($event)"
                placeholder="Contoh : Diskominfo"
                bindLabel="satuan_kerja_nama"
                typeToSearchText="Masukan Organisasi"
                formControlName="access_control"
              />
            </div>

            <!-- Jabatan -->
            <div
              *ngIf="fdp.controls.length > 0"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Jabatan
                <span [ngClass]="jds.text('danger')">*</span>
              </label>

              <jds-bi-accordion
                #accOrg="jdsBiAccordion"
                [destroyOnHide]="false"
                [closeOthers]="false"
                [colorScheme]="colorScheme"
                [ngClass]="['accordion-organization']"
              >
                <ng-container *ngFor="let dp of fdp.controls; let i = index">
                  <ng-container [formGroup]="dp">
                    <jds-bi-panel
                      [title]="organizationStructureData[i].satuan_kerja_nama"
                    >
                      <ng-template jdsBiPanelContent>
                        <ng-container
                          *ngFor="let l0 of dp.controls; let ill0 = index"
                        >
                          <app-form-access-control
                            [accessControlInput]="l0"
                            [organizationStructureDataInput]="
                              organizationStructureData[i].data[ill0]
                            "
                          />
                        </ng-container>
                      </ng-template>
                    </jds-bi-panel>
                  </ng-container>
                </ng-container>
              </jds-bi-accordion>
            </div>

            <!-- Status Data -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Status Data
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <div>
                <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
                  <input
                    [ngClass]="[jds.formCheckInput]"
                    (click)="onSelectedIsPermanent($event.target.value)"
                    value="false"
                    type="radio"
                    formControlName="is_permanent"
                  />
                  <label [ngClass]="[jds.formCheckLabel]"> Sementara </label>
                </div>
                <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
                  <input
                    [ngClass]="[jds.formCheckInput]"
                    (click)="onSelectedIsPermanent($event.target.value)"
                    value="true"
                    type="radio"
                    formControlName="is_permanent"
                  />
                  <label [ngClass]="[jds.formCheckLabel]"> Tetap </label>
                </div>
              </div>
              <ng-container
                *ngIf="
                  f.is_permanent?.invalid &&
                  (f.is_permanent?.dirty || f.is_permanent?.touched)
                "
              >
                <div
                  *ngIf="f.is_permanent?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Periode Data Sementara -->
            <div
              *ngIf="isPeriod"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Periode Data Sementara
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <div [ngClass]="jds.row">
                <div [ngClass]="jds.col(4)">
                  <input
                    [colorScheme]="colorScheme"
                    [ngClass]="jds.py(9)"
                    jdsBiInput
                    type="month"
                    formControlName="period"
                  />
                  <ng-container
                    *ngIf="
                      f.period?.invalid &&
                      (f.period?.dirty || f.period?.touched)
                    "
                  >
                    <div
                      *ngIf="f.period?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                  </ng-container>
                </div>
              </div>
            </div>

            <!-- Tags -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Tags <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                class="select-tags"
                [items]="tagInputData$ | async"
                [addTag]="addTagFn"
                [multiple]="true"
                [selectOnTab]="true"
                [typeahead]="tagInput$"
                [loading]="tagInputIsLoading"
                [hideSelected]="true"
                [minTermLength]="2"
                placeholder="Contoh : Diskominfo, Provinsi Jawa Barat"
                bindValue="tag"
                bindLabel="tag"
                typeToSearchText="Masukan Tag"
                formControlName="tags"
              />
              <div [ngClass]="[jds.formText, jds.text('muted')]">
                Tekan Tab/Enter ketika selesai menambahkan tag.
              </div>
              <ng-container
                *ngIf="f.tags?.invalid && (f.tags?.dirty || f.tags?.touched)"
              >
                <div
                  *ngIf="f.tags?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
              <div
                *ngIf="!tagInputValid"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Panjang maksimal 48 karakter.
              </div>
            </div>

            <!-- Sumber Data -->
            <div
              *ngIf="satudataUser.role_name === 'walidata'"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Sumber Data
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <div>
                <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
                  <input
                    [ngClass]="[jds.formCheckInput]"
                    value="false"
                    type="radio"
                    formControlName="is_realtime"
                  />
                  <label [ngClass]="[jds.formCheckLabel]"> Statis </label>
                </div>
                <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
                  <input
                    [ngClass]="[jds.formCheckInput]"
                    value="true"
                    type="radio"
                    formControlName="is_realtime"
                  />
                  <label [ngClass]="[jds.formCheckLabel]"> Realtime </label>
                </div>
              </div>
              <ng-container
                *ngIf="
                  f.is_realtime?.invalid &&
                  (f.is_realtime?.dirty || f.is_realtime?.touched)
                "
              >
                <div
                  *ngIf="f.is_realtime?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Lisensi -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="[jds.formLabel, jds.mb(0)]">Lisensi</label>
              <span
                [ngClass]="[
                  jds.formText,
                  jds.text('muted'),
                  jds.d('block'),
                  jds.mb(5)
                ]"
              >
                Ketahui lebih lanjut mengenai lisensi
                <a
                  [ngClass]="[
                    jds.textDecoration('underline'),
                    jds.text('primary')
                  ]"
                  [routerLink]="['/help']"
                  [queryParams]="{ topic: 'dataset' }"
                  fragment="license-dataset"
                >
                  disini
                </a>
              </span>
              <ng-select
                #licenseSelect
                [items]="licenseData$ | async"
                bindValue="id"
                bindLabel="name"
                placeholder="Lisensi"
                formControlName="license_id"
              />
            </div>
          </div>
        </ng-template>
      </jds-bi-panel>

      <jds-bi-panel id="accordion-dataset-update-metadata">
        <ng-template jdsBiPanelTitle>
          <div
            [ngClass]="[jds.fs(18), jds.p(20)]"
            [style.width.%]="100"
            (click)="panelCollapse('accordion-dataset-update-metadata')"
          >
            Metadata
          </div>
        </ng-template>
        <ng-template jdsBiPanelContent>
          <div [ngClass]="[jds.p(20)]">
            <!-- Pengukuran Dataset -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Pengukuran Dataset
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Contoh : Indeks Keamanan Informasi"
                formControlName="pengukuran_dataset"
              />
              <ng-container
                *ngIf="
                  f.pengukuran_dataset?.invalid &&
                  (f.pengukuran_dataset?.dirty || f.pengukuran_dataset?.touched)
                "
              >
                <div
                  *ngIf="f.pengukuran_dataset?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="f.pengukuran_dataset?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Tingkat Penyajian Dataset -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Tingkat Penyajian Dataset
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Contoh : Kota dan Kabupaten"
                formControlName="tingkat_penyajian_dataset"
              />
              <ng-container
                *ngIf="
                  f.tingkat_penyajian_dataset?.invalid &&
                  (f.tingkat_penyajian_dataset?.dirty ||
                    f.tingkat_penyajian_dataset?.touched)
                "
              >
                <div
                  *ngIf="f.tingkat_penyajian_dataset?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="f.tingkat_penyajian_dataset?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Cakupan Dataset -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Cakupan Dataset
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Seluruh..."
                formControlName="cakupan_dataset"
              />
              <ng-container
                *ngIf="
                  f.cakupan_dataset?.invalid &&
                  (f.cakupan_dataset?.dirty || f.cakupan_dataset?.touched)
                "
              >
                <div
                  *ngIf="f.cakupan_dataset?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="f.cakupan_dataset?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Produsen -->
            <div
              *ngIf="satudataUser.role_name === 'walidata'"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Produsen <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                #organisasiSelect
                [items]="organizationData$ | async"
                (change)="onSelectedOrganization($event)"
                (clear)="onClearOrganization()"
                bindValue="kode_skpd"
                bindLabel="nama_skpd"
                placeholder="Produsen"
                formControlName="kode_skpd"
              />
              <ng-container
                *ngIf="
                  f.kode_skpd?.invalid &&
                  (f.kode_skpd?.dirty || f.kode_skpd?.touched)
                "
              >
                <div
                  *ngIf="f.kode_skpd?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Bidang -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">Bidang</label>
              <ng-select
                #organisasiSelect
                [items]="organizationSubData$ | async"
                (change)="onSelectedOrganizationSub($event)"
                (clear)="onClearOrganizationSub()"
                bindValue="kode_skpdsub"
                bindLabel="nama_skpdsub"
                placeholder="Bidang"
                formControlName="kode_skpdsub"
              />
            </div>

            <!-- Penanggung Jawab -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">Penanggung Jawab</label>
              <ng-select
                #penanggungjawabSelect
                [items]="organizationUnitData$ | async"
                (change)="onSelectedOrganizationUnit($event)"
                (clear)="onClearOrganizationUnit()"
                bindValue="kode_skpdunit"
                bindLabel="nama_skpdunit"
                placeholder="Penanggung Jawab"
                formControlName="kode_skpdunit"
              />
            </div>

            <!-- Kontak Produsen -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Kontak Produsen
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Contoh : 0222502888"
                formControlName="kontak_produsen"
              />
              <ng-container
                *ngIf="
                  f.kontak_produsen?.invalid &&
                  (f.kontak_produsen?.dirty || f.kontak_produsen?.touched)
                "
              >
                <div
                  *ngIf="f.kontak_produsen?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="f.kontak_produsen?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Kode Indikator -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">Kode Indikator</label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Kode Indikator"
                formControlName="kode_indikator"
              />
              <ng-container
                *ngIf="
                  f.kode_indikator?.invalid &&
                  (f.kode_indikator?.dirty || f.kode_indikator?.touched)
                "
              >
                <div
                  *ngIf="f.kode_indikator?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Bidang Urusan -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Bidang Urusan <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                #bidangUrusanSelect
                [items]="businessFieldData$ | async"
                (change)="onSelectedBusinessField($event)"
                (clear)="onClearBusinessField()"
                bindValue="value"
                bindLabel="label"
                placeholder="Bidang Urusan"
                formControlName="kode_bidang_urusan"
              />
              <ng-container
                *ngIf="
                  f.kode_bidang_urusan?.invalid &&
                  (f.kode_bidang_urusan?.dirty || f.kode_bidang_urusan?.touched)
                "
              >
                <div
                  *ngIf="f.kode_bidang_urusan?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Satuan Dataset -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Satuan Dataset
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Contoh : Nilai"
                formControlName="satuan_dataset"
              />
              <ng-container
                *ngIf="
                  f.satuan_dataset?.invalid &&
                  (f.satuan_dataset?.dirty || f.satuan_dataset?.touched)
                "
              >
                <div
                  *ngIf="f.satuan_dataset?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="f.satuan_dataset?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Frekuensi Dataset -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Frekuensi Dataset
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-select
                #frequencyDatasetSelect
                [items]="frequencyDatasetData"
                placeholder="Frekuensi Dataset"
                formControlName="frekuensi_dataset"
              />
              <ng-container
                *ngIf="
                  f.frekuensi_dataset?.invalid &&
                  (f.frekuensi_dataset?.dirty || f.frekuensi_dataset?.touched)
                "
              >
                <div
                  *ngIf="f.frekuensi_dataset?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>

            <!-- Dimensi Dataset -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">
                Dimensi Dataset
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <div [ngClass]="jds.row">
                <div [ngClass]="jds.col(3)">
                  <ng-select
                    #dimensionDatasetStartSelect
                    [items]="dimensionDatasetStartData"
                    (change)="onSelectedDimensionStart($event)"
                    placeholder="Dimensi Dataset Awal"
                    formControlName="dimensi_dataset_awal"
                  />
                  <ng-container
                    *ngIf="
                      f.dimensi_dataset_awal?.invalid &&
                      (f.dimensi_dataset_awal?.dirty ||
                        f.dimensi_dataset_awal?.touched)
                    "
                  >
                    <div
                      *ngIf="f.dimensi_dataset_awal?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                  </ng-container>
                </div>
                <div [ngClass]="jds.col(3)">
                  <ng-select
                    #dimensionDatasetEndSelect
                    [items]="dimensionDatasetEndData"
                    placeholder="Dimensi Dataset Akhir"
                    formControlName="dimensi_dataset_akhir"
                  />
                  <ng-container
                    *ngIf="
                      f.dimensi_dataset_akhir?.invalid &&
                      (f.dimensi_dataset_akhir?.dirty ||
                        f.dimensi_dataset_akhir?.touched)
                    "
                  >
                    <div
                      *ngIf="f.dimensi_dataset_akhir?.errors.required"
                      [ngClass]="[jds.formText, jds.text('danger')]"
                    >
                      Harus diisi
                    </div>
                  </ng-container>
                </div>
              </div>
            </div>

            <!-- Sumber External -->
            <div [ngClass]="jds.mb(16)">
              <label [ngClass]="jds.formLabel">Sumber External</label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Contoh : Dinas Komunikasi dan Informatika"
                formControlName="sumber_external"
              />
              <ng-container
                *ngIf="
                  f.sumber_external?.invalid &&
                  (f.sumber_external?.dirty || f.sumber_external?.touched)
                "
              >
                <div
                  *ngIf="f.sumber_external?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <hr />

            <ng-container *ngFor="let dm of fdm.controls; let i = index">
              <ng-container [formGroup]="dm">
                <div [ngClass]="jds.row">
                  <div [ngClass]="jds.col(5)">
                    <div [ngClass]="jds.mb(16)">
                      <input
                        [colorScheme]="colorScheme"
                        jdsBiInput
                        type="text"
                        placeholder="Kolom"
                        formControlName="key"
                      />
                      <ng-container
                        *ngIf="
                          dm['controls'].key?.invalid &&
                          (dm['controls'].key?.dirty ||
                            dm['controls'].key?.touched)
                        "
                      >
                        <div
                          *ngIf="dm['controls'].key?.errors.maxlength"
                          [ngClass]="[jds.formText, jds.text('danger')]"
                        >
                          Panjang maksimal 255 karakter.
                        </div>
                      </ng-container>
                    </div>
                  </div>
                  <div [ngClass]="[jds.col(5), jds.ps(0)]">
                    <div [ngClass]="jds.mb(16)">
                      <input
                        [colorScheme]="colorScheme"
                        jdsBiInput
                        type="text"
                        placeholder="Value"
                        formControlName="value"
                      />
                      <ng-container
                        *ngIf="
                          dm['controls'].value?.invalid &&
                          (dm['controls'].value?.dirty ||
                            dm['controls'].value?.touched)
                        "
                      >
                        <div
                          *ngIf="dm['controls'].value?.errors.maxlength"
                          [ngClass]="[jds.formText, jds.text('danger')]"
                        >
                          Panjang maksimal 255 karakter.
                        </div>
                      </ng-container>
                    </div>
                  </div>
                  <div [ngClass]="[jds.col(2), jds.ps(0)]">
                    <div
                      [ngClass]="[jds.d('flex'), jds.justifyContent('center')]"
                    >
                      <button
                        [ngClass]="[
                          jds.button,
                          jds.buttonDanger,
                          jds.d('flex'),
                          jds.alignItems('center')
                        ]"
                        (click)="removeMetadata(i)"
                        type="button"
                      >
                        <jds-bi-icon
                          [ngClass]="jds.me(8)"
                          name="trash"
                        />
                        <span>Hapus</span>
                      </button>
                    </div>
                  </div>
                </div>
              </ng-container>
            </ng-container>

            <div [ngClass]="jds.mb(16)">
              <button
                [ngClass]="[
                  jds.button,
                  jds.buttonLink,
                  jds.d('flex'),
                  jds.alignItems('center')
                ]"
                (click)="addMetadata()"
                type="button"
              >
                <jds-bi-icon
                  [ngClass]="jds.me(8)"
                  name="circle-plus"
                />
                <span>Tambah Kolom Baru</span>
              </button>
            </div>
          </div>
        </ng-template>
      </jds-bi-panel>

      <jds-bi-panel id="accordion-dataset-update-worksheet">
        <ng-template jdsBiPanelTitle>
          <div
            [ngClass]="[jds.fs(18), jds.p(20)]"
            [style.width.%]="100"
            (click)="panelCollapse('accordion-dataset-update-worksheet')"
          >
            Baris Data
          </div>
        </ng-template>
        <ng-template jdsBiPanelContent>
          <div [ngClass]="[jds.p(20)]">
            <div [hidden]="isRealtime">
              <div [hidden]="!accessBigData">
                <div [ngClass]="[jds.alert, jds.alertPrimary, jds.mb(24)]">
                  <div [ngClass]="[jds.d('flex')]">
                    <div [ngClass]="jds.alertIcon">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="circle-info"
                      />
                    </div>
                    <div>
                      <ul [ngClass]="[jds.fs(14), jds.ps(24), jds.mb(0)]">
                        <li [ngClass]="[jds.mb(16)]">
                          Untuk menyalin dan menempelkan, Anda dapat menggunakan
                          pintasan keyboard berikut:
                          <br />
                          PC:
                          <span [ngClass]="jds.fontWeight('bold')"
                            >Ctrl + C</span
                          >
                          untuk Menyalin, dan
                          <span [ngClass]="jds.fontWeight('bold')"
                            >Ctrl + V</span
                          >
                          untuk Menempelkan. <br />
                          Mac:
                          <span [ngClass]="jds.fontWeight('bold')">⌘ + C</span>
                          untuk Menyalin, dan
                          <span [ngClass]="jds.fontWeight('bold')">⌘ + V</span>
                          untuk Menempelkan.
                        </li>
                        <li [ngClass]="[jds.mb(16)]">
                          Untuk berpindah antar baris, Anda dapat menggunakan
                          pintasan dengan menekan
                          <span [ngClass]="jds.fontWeight('bold')">Tab</span>
                          pada keyboard.
                        </li>
                        <li>
                          Pelajari panduan lengkap dalam mengunggah dan
                          melakukan cleansing data
                          <a
                            [ngClass]="[
                              jds.text('primary'),
                              jds.textDecoration('underline')
                            ]"
                            target="_blank"
                            rel="noopener"
                            href="https://drive.google.com/file/d/11zhM1MI8WQErjUflYB9ZcYyLbF7mt1rU/view"
                          >
                            disini </a
                          >.
                        </li>
                      </ul>
                    </div>
                  </div>
                </div>

                <!-- Spreadsheet -->
                <div
                  class="spreadsheet"
                  #spreadsheet
                  [ngClass]="jds.mb(16)"
                >
                  <div
                    class="input-spreadsheet"
                    id="input-spreadsheet"
                  ></div>
                </div>
              </div>

              <ng-container
                *ngIf="!accessBigData && accessinfoBigData === 'can_access'"
              >
                <div [ngClass]="[jds.alert, jds.alertDanger]">
                  <div [ngClass]="[jds.d('flex')]">
                    <div [ngClass]="jds.alertIcon">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="user-lock"
                      />
                    </div>
                    <div>
                      Untuk melihat dataset ini dibutuhkan izin akses khusus.
                      Silakan hubungi Walidata melalui nomor Whatsapp ({{
                        whatsapp
                      }}) atau email (data&#64;jabarprov.go.id) untuk mendapatkan
                      akses.
                    </div>
                  </div>
                </div>
              </ng-container>

              <ng-container
                *ngIf="!accessBigData && accessinfoBigData === 'app'"
              >
                <div [ngClass]="[jds.alert, jds.alertDanger]">
                  <div [ngClass]="[jds.d('flex')]">
                    <div [ngClass]="jds.alertIcon">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="ban"
                      />
                    </div>
                    <div>Sumber Data tidak ditemukan.</div>
                  </div>
                </div>
              </ng-container>

              <ng-container
                *ngIf="!accessBigData && accessinfoBigData === 'app_service'"
              >
                <div [ngClass]="[jds.alert, jds.alertDanger]">
                  <div [ngClass]="[jds.d('flex')]">
                    <div [ngClass]="jds.alertIcon">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="ban"
                      />
                    </div>
                    <div>Table Data tidak ditemukan.</div>
                  </div>
                </div>
              </ng-container>

              <ng-container
                *ngIf="!accessBigData && accessinfoBigData === 'not_found'"
              >
                <div [ngClass]="[jds.alert, jds.alertDanger]">
                  <div [ngClass]="[jds.d('flex')]">
                    <div [ngClass]="jds.alertIcon">
                      <jds-bi-icon
                        [ngClass]="jds.me(8)"
                        name="ban"
                      />
                    </div>
                    <div>Data tidak ditemukan.</div>
                  </div>
                </div>
              </ng-container>
            </div>

            <ng-container
              *ngIf="isRealtime && satudataUser.role_name === 'walidata'"
            >
              <!-- Schema -->
              <div [ngClass]="jds.mb(16)">
                <label [ngClass]="jds.formLabel">
                  Schema <span [ngClass]="jds.text('danger')">*</span>
                </label>
                <ng-select
                  #schemaSelect
                  [items]="schemaData"
                  (ngModelChange)="onSelectedSchema($event)"
                  (clear)="onClearSchema()"
                  bindValue="schema"
                  bindLabel="schema"
                  placeholder="Schema"
                  formControlName="schema"
                />
                <ng-container
                  *ngIf="
                    f.schema?.invalid && (f.schema?.dirty || f.schema?.touched)
                  "
                >
                  <div
                    *ngIf="f.schema?.errors.required"
                    [ngClass]="[jds.formText, jds.text('danger')]"
                  >
                    Harus diisi
                  </div>
                </ng-container>
              </div>

              <!-- Table -->
              <div [ngClass]="jds.mb(16)">
                <label [ngClass]="jds.formLabel">
                  Table <span [ngClass]="jds.text('danger')">*</span>
                </label>
                <ng-select
                  #tableSelect
                  [items]="tableData"
                  bindValue="table"
                  bindLabel="table"
                  placeholder="Table"
                  formControlName="table"
                />
                <ng-container
                  *ngIf="
                    f.table?.invalid && (f.table?.dirty || f.table?.touched)
                  "
                >
                  <div
                    *ngIf="f.table?.errors.required"
                    [ngClass]="[jds.formText, jds.text('danger')]"
                  >
                    Harus diisi
                  </div>
                </ng-container>
              </div>
            </ng-container>

            <ng-container
              *ngIf="isRealtime && satudataUser.role_name === 'opd'"
            >
              <div [ngClass]="[jds.alert, jds.alertPrimary, jds.mb(12)]">
                <div [ngClass]="[jds.d('flex')]">
                  <div [ngClass]="jds.alertIcon">
                    <jds-bi-icon
                      [ngClass]="jds.me(8)"
                      name="clock-rotate-left"
                    />
                  </div>
                  <div>Data Realtime</div>
                </div>
              </div>
            </ng-container>
          </div>
        </ng-template>
      </jds-bi-panel>
    </jds-bi-accordion>

    <div
      *ngIf="isDatasetChange"
      [ngClass]="[jds.card, jds.mt(24)]"
    >
      <div [ngClass]="jds.cardBody">
        <div [ngClass]="[jds.px(20), jds.py(10)]">
          <label [ngClass]="jds.formLabel">
            Berikan informasi terkait perubahan yang dilakukan pada dataset ini
          </label>
          <div [ngClass]="[jds.alert, jds.alertPrimary, jds.mb(12)]">
            <div [ngClass]="[jds.d('flex')]">
              <div [ngClass]="jds.alertIcon">
                <jds-bi-icon
                  [ngClass]="jds.me(8)"
                  name="circle-info"
                />
              </div>
              <div>
                Contoh: Melakukan perubahan pada judul dataset dan nilai dataset
                yang terletak di row nomor 70.
              </div>
            </div>
          </div>
          <textarea
            [colorScheme]="colorScheme"
            jdsBiInput
            placeholder="Tuliskan catatan perubahan pada dataset disini"
            rows="5"
            formControlName="change"
          ></textarea>
          <ng-container
            *ngIf="f.change?.invalid && (f.change?.dirty || f.change?.touched)"
          >
            <div
              *ngIf="f.change?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
            <div
              *ngIf="f.change?.errors.minlength"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Panjang minimal 15 karakter.
            </div>
          </ng-container>
        </div>
      </div>
    </div>

    <div
      [ngClass]="[
        jds.d('flex'),
        jds.justifyContent('end'),
        jds.mt(32),
        jds.mb(10)
      ]"
    >
      <ng-container *ngIf="filter.from === 'update' || filter.from === 'draft'">
        <span
          [ngClass]="[jds.d('inline-block')]"
          [popperDisabled]="!isDisabledButtonDraft"
          [popperPlacement]="'top'"
          [popperTrigger]="'hover'"
          popper="Judul, Topik, dan Organisasi harus terisi"
        >
          <button
            [ngClass]="[jds.button, jds.buttonDefault]"
            [disabled]="isDisabledButtonDraft"
            type="submit"
            name="draft"
          >
            Simpan Sebagai Draf
          </button>
        </span>
      </ng-container>

      <button
        [ngClass]="[jds.button, jds.buttonPrimary, jds.ms(16)]"
        [disabled]="!myForm.valid"
        type="submit"
        name="next"
      >
        Selanjutnya
      </button>
    </div>
  </form>
</section>
